;KFX_Convert.au3

Func _Exit()
	_PluginSaveSettings()
	Exit
EndFunc   ;==>_Exit


Func _StartConverting()
	
	If GUICtrlRead($InputFile_Input) = "" Or GUICtrlRead($OutputFile_Input) = "" Then
		MsgBox(262160, _ISNPlugin_Get_langstring(17), _ISNPlugin_Get_langstring(23), 0, $GUI)
		Return
	EndIf
	

	;Reset
	$ControlCounter = 1
	$TabpageCounter = 0
	_GUICtrlEdit_SetText($LogEdit, "")
	$Inputfile = _ISNPlugin_Resolve_ISN_AutoIt_Studio_Variable(GUICtrlRead($InputFile_Input))
	$Outputfile = _ISNPlugin_Resolve_ISN_AutoIt_Studio_Variable(GUICtrlRead($OutputFile_Input))
	$TabDisplayRectX = GUICtrlRead($TabcontrolsXOffset_input)
	$TabDisplayRectY = GUICtrlRead($TabcontrolsYOffset_input)
	
	If GUICtrlRead($ignoreExstyle_checkbox) = $GUI_CHECKED Then
		$IgnoreExStyle = "1"
	Else
		$IgnoreExStyle = "0"
	EndIf

	If GUICtrlRead($ignoreStyle_checkbox) = $GUI_CHECKED Then
		$IgnoreStyle = "1"
	Else
		$IgnoreStyle = "0"
	EndIf
	
	_log(_ISNPlugin_Get_langstring(9) & @CRLF & @CRLF)
	
	_log(_ISNPlugin_Get_langstring(10) & ":" & @TAB & $Inputfile & @CRLF)
	_log(_ISNPlugin_Get_langstring(11) & ":" & @TAB & $Outputfile & @CRLF)
	_log(@CRLF)
	;Check if Outputfile exists
	If FileExists($Outputfile) Then
		$Result = MsgBox(4 + 262144 + 48, _ISNPlugin_Get_langstring(16), _ISNPlugin_Get_langstring(15), 0, $GUI)
		If @error Or $Result = 7 Then Return
	EndIf
	
	;Open Koda XML file
	$XML_Handle = _XMLFileOpen($Inputfile)
	If @error Then
		MsgBox(262160, _ISNPlugin_Get_langstring(17), _ISNPlugin_Get_langstring(19) & @CRLF & @CRLF & "Error Code: " & @error & @CRLF & "Extended: " & @extended, 0, $GUI)
		Return
	EndIf
	
	;Open new ISF File for writing
	_log(_ISNPlugin_Get_langstring(22) & @CRLF)
	$ISF_File = FileOpen($Outputfile, 2 + $FO_UTF8_NOBOM)
	If $ISF_File = -1 Then
		MsgBox(262160, _ISNPlugin_Get_langstring(17), _ISNPlugin_Get_langstring(20), 0, $GUI)
		Return
	EndIf
	
	
	;Setup GUI
	Local $GuiHandle = _Get_KXF_AtribValue("/object[@type='TAForm']", "name")
	Local $GuiTitle = _Get_KXF_Value("/object/properties/property[@name='Caption']")
	Local $GuiX = _Get_KXF_Value("/object/properties/property[@name='Left']")
	Local $GuiY = _Get_KXF_Value("/object/properties/property[@name='Top']")
	Local $GuiHeight = _Get_KXF_Value("/object/properties/property[@name='Height']")
	Local $GuiWidth = _Get_KXF_Value("/object/properties/property[@name='Width']")
	Local $GuiStyle = _Get_KXF_Value("/object/properties/property[@name='Style']")
	Local $GuiExStyle = _Get_KXF_Value("/object/properties/property[@name='ExStyle']")
	Local $GuiColor = _Get_KXF_Value("/object/properties/property[@name='Color']")
	
	;Adjust some settings
	$GuiHandle = _Return_Handle_with_Dollar($GuiHandle)
	$GuiColor = _Get_ColorFromKXF($GuiColor)
	$GuiStyle = _Get_StyleFromKXF($GuiStyle, "gui") ;Update Style
	$GuiExStyle = _Get_ExStyleFromKXF($GuiExStyle, "gui") ;Update ExStyle
	$GuiHeight = $GuiHeight - $Clientsize_diff_height ;Update Gui Height
	$GuiWidth = $GuiWidth - $Clientsize_diff_width ;Update Gui Widfth
	
	
	;Write GUI in ISF
	_log(StringReplace(_ISNPlugin_Get_langstring(12), "%1", $GuiHandle) & @CRLF)
	FileWriteLine($ISF_File, "#cs")
	FileWriteLine($ISF_File, "[gui]")
	FileWriteLine($ISF_File, "title=" & $GuiTitle)
	FileWriteLine($ISF_File, "breite=" & $GuiWidth)
	FileWriteLine($ISF_File, "hoehe=" & $GuiHeight)
	FileWriteLine($ISF_File, "style=" & $GuiStyle)
	FileWriteLine($ISF_File, "exstyle=" & $GuiExStyle)
	FileWriteLine($ISF_File, "bgcolour=" & $GuiColor)
	FileWriteLine($ISF_File, "bgimage=none")
	FileWriteLine($ISF_File, "handle=" & $GuiHandle)

	;Start control conversation
	_Converter_ConvertChilds("/object/components")
	
	;Final stuff
	FileWriteLine($ISF_File, "#ce")
	FileWriteLine($ISF_File, "")
	FileClose($ISF_File)
	IniWrite($Outputfile, "tab", "pages", $TabpageCounter)
	
	_log(@CRLF)
	_log(_ISNPlugin_Get_langstring(14) & @CRLF)
	MsgBox(262144 + 64, _ISNPlugin_Get_langstring(18), _ISNPlugin_Get_langstring(14), 0, $GUI)
	
	
EndFunc   ;==>_StartConverting


Func _Converter_ConvertChilds($Path = "", $Tabpage = "-1", $XOffset = "", $YOffset = "", $RootControl = "")
	
	;And now the controls...
	;Get Count Array
	Local $ControlCountArray = _XMLGetChildNodes($Path)
	If IsArray($ControlCountArray) Then
		
		For $cnt = 1 To UBound($ControlCountArray) - 1
			

			$ControlCounter = $ControlCounter + 1
			_log("Set XML Path to: " & $Path & @CRLF)
			Local $ControlSection = "0x" & Hex($ControlCounter, 8)
			Local $ControlHandle = _Get_KXF_AtribValue($Path & "/object[" & $cnt & "]", "name")
			Local $ControlX = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Left']")
			Local $ControlY = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Top']")
			Local $ControlHeight = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Height']")
			Local $ControlWidth = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Width']")
			Local $ControlStyle = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='CtrlStyle']")
			Local $ControlExStyle = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='CtrlExStyle']")
			Local $ControlResizing = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Resizing']")
			Local $ControlText = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Caption']")
			Local $ControlBgColor = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Color']")
			Local $ControlTextColor = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Font.Color']")
			Local $ControlType = _Get_KXF_AtribValue($Path & "/object[" & $cnt & "]", "type")
			Local $ControlFont = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Font.Name']")
			Local $ControlFontSize = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Font.Height']")
			Local $ControlFontAttribute = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Font.Style']")
			Local $ControlFontStyle = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Font.Style']")
			Local $ControlPicturePath = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='PicturePath']")
			Local $ControlEnabled = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Enabled']")
			Local $ControlVisible = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Visible']")
			Local $ControlTooltip = _Get_KXF_Value($Path & "/object[" & $cnt & "]/properties/property[@name='Hint']")
			Local $ForTabPage = -1
			
			$ControlType = _Get_TypeFromKXF($ControlType) ;Update Control type
			$ControlBgColor = _Get_ColorFromKXF($ControlBgColor) ;Update BgColor
			$ControlTextColor = _Get_ColorFromKXF($ControlTextColor) ;Update Font Color
			$ControlFontSize = _Get_KXFConvertInt8($ControlFontSize) ;Update Font Size
			$ControlFontAttribute = _Get_FontAttributeFromKXF($ControlFontAttribute) ;Update Font Atributes
			$ControlFontStyle = _Get_FontStyleFromKXF($ControlFontStyle) ;Update Font weight
			$ControlStyle = _Get_StyleFromKXF($ControlStyle, $ControlType) ;Update Style
			$ControlExStyle = _Get_ExStyleFromKXF($ControlExStyle, $ControlType) ;Update ExStyle
			$ControlHandle = _Return_Handle_with_Dollar($ControlHandle)
			$ControlResizing = _Get_ResizingFromKXF($ControlResizing) ;Update Resizing
			
			
			If $ControlFont = "" Then $ControlFont = "MS Sans Serif"
			If $ControlFontStyle = "" Then $ControlFontStyle = "400"
			If $ControlTextColor = "" Then $ControlTextColor = "0x000000"
			If $ControlFontAttribute = "" Then $ControlFontAttribute = "0"
			If $ControlFontSize = "" Then $ControlFontSize = "8"
			If $XOffset <> "" Then $ControlX = $ControlX + $XOffset
			If $YOffset <> "" Then $ControlY = $ControlY + $YOffset
			If $Tabpage <> "-1" Then
				If $RootControl <> "group" Then
					$ControlX = $ControlX + $TabDisplayRectX
					$ControlY = $ControlY + $TabDisplayRectY
				EndIf
				$ForTabPage = $Tabpage
			EndIf
			Local $ControlState = ""
			If $ControlVisible = "False" Then
				$ControlState = "$GUI_HIDE"
			Else
				$ControlState = "$GUI_SHOW"
			EndIf
			If $ControlEnabled = "False" Then $ControlState = $ControlState & "+$GUI_DISABLE"
			If $ControlType = "tab" Then $ControlSection = "tab"
			
			
			
			;Ignore list
			If $ControlType = "toolbar" Then ContinueLoop ;Ignore this control at the moment
			If $ControlType = "menu" Then ContinueLoop ;Ignore this control at the moment
			
			;Write Control in ISF
			If $ControlType <> "TTabSheet" Then
				_log(StringReplace(_ISNPlugin_Get_langstring(13), "%1", $ControlHandle & " (" & $ControlType & ")") & @CRLF)
				FileWriteLine($ISF_File, "[" & $ControlSection & "]")
				FileWriteLine($ISF_File, "id=" & $ControlHandle)
				FileWriteLine($ISF_File, "x=" & $ControlX)
				FileWriteLine($ISF_File, "y=" & $ControlY)
				FileWriteLine($ISF_File, "width=" & $ControlWidth)
				FileWriteLine($ISF_File, "height=" & $ControlHeight)
				FileWriteLine($ISF_File, "text=" & $ControlText)
				FileWriteLine($ISF_File, "type=" & $ControlType)
				FileWriteLine($ISF_File, "tabpage=" & $Tabpage)
				FileWriteLine($ISF_File, "func=")
				FileWriteLine($ISF_File, "iconindex=")
				FileWriteLine($ISF_File, "style=" & $ControlStyle)
				FileWriteLine($ISF_File, "exstyle=" & $ControlExStyle)
				FileWriteLine($ISF_File, "state=" & $ControlState)
				FileWriteLine($ISF_File, "tooltip=" & $ControlTooltip)
				FileWriteLine($ISF_File, "bgimage=" & $ControlPicturePath)
				FileWriteLine($ISF_File, "textcolour=" & $ControlTextColor)
				FileWriteLine($ISF_File, "bgcolour=" & $ControlBgColor)
				FileWriteLine($ISF_File, "font=" & $ControlFont)
				FileWriteLine($ISF_File, "fontsize=" & $ControlFontSize)
				FileWriteLine($ISF_File, "fontstyle=" & $ControlFontStyle)
				FileWriteLine($ISF_File, "fontattribute=" & $ControlFontAttribute)
				FileWriteLine($ISF_File, "resize=" & $ControlResizing)
			Else
				
				
				$TabpageCounter = $TabpageCounter + 1
				
				;Write TabPages in ISF
				$ForTabPage = $TabpageCounter - 1
				FileWriteLine($ISF_File, "[TABPAGE" & $TabpageCounter & "]")
				FileWriteLine($ISF_File, "page=" & $TabpageCounter)
				FileWriteLine($ISF_File, "text=" & $ControlText)
				FileWriteLine($ISF_File, "handle=" & $ControlHandle)
				FileWriteLine($ISF_File, "textmode=text")
			EndIf
			
			;Check additional Subcomponents (for groups)
			Local $AdditionalGroupCountArray = _XMLGetChildNodes($Path & "/object[" & $cnt & "]/components")
			If IsArray($AdditionalGroupCountArray) Then _Converter_ConvertChilds($Path & "/object[" & $cnt & "]/components", $ForTabPage, $ControlX, $ControlY, $ControlType)

		Next
		

		
	EndIf
	
EndFunc   ;==>_Converter_ConvertChilds


Func _Get_KXF_Value($Path = "")
	Local $Value = ""
	If $Path = "" Then Return ""
	Local $ResultArray = _XMLGetChildText($Path)
	If IsArray($ResultArray) Then $Value = $ResultArray[1]
	Return $Value
EndFunc   ;==>_Get_KXF_Value

Func _Get_KXF_AtribValue($Path = "", $Attrib = "")
	Local $Value = ""
	If $Path = "" Then Return ""
	Local $Result = _XMLGetAttrib($Path, $Attrib)
	If $Result <> -1 And StringLen($Result) > 0 Then $Value = $Result
	Return $Value
EndFunc   ;==>_Get_KXF_AtribValue


Func _Get_TypeFromKXF($Input = "")
	If $Input = "" Then Return ""
	
	Switch $Input

		Case "TATab"
			$Input = "tab"
			
		Case "TAButton"
			$Input = "button"
			
		Case "TALabel"
			$Input = "label"

		Case "TACheckbox"
			$Input = "checkbox"

		Case "TARadio"
			$Input = "radio"

		Case "TAGroup"
			$Input = "group"

		Case "TACombo"
			$Input = "combo"

		Case "TAInput"
			$Input = "input"
			
		Case "TAEdit"
			$Input = "edit"
			
		Case "TAList"
			$Input = "listbox"
			
		Case "TAPic"
			$Input = "image"

		Case "TAIcon"
			$Input = "icon"

		Case "TAGraphic"
			$Input = "graphic"

		Case "TADate"
			$Input = "date"
			
		Case "TAMonthCal"
			$Input = "calendar"

		Case "TAProgress"
			$Input = "progress"
			
		Case "TAUpdown"
			$Input = "updown"
			
		Case "TASlider"
			$Input = "slider"
			
		Case "TAListView"
			$Input = "listview"

		Case "TATreeView"
			$Input = "treeview"

		Case "TAStatusBar"
			$Input = "statusbar"
			
		Case "TAIPAddress"
			$Input = "ip"
			
		Case "TAToolBar"
			$Input = "toolbar"

		Case "TADummy"
			$Input = "dummy"

		Case "TADummy"
			$Input = "dummy"

		Case "TAMenu"
			$Input = "menu"
			
	EndSwitch
	
	Return $Input
EndFunc   ;==>_Get_TypeFromKXF



Func _Get_ColorFromKXF($Input = "")
	If $Input = "" Then Return ""
	
	Switch $Input
		
		Case "clBlack"
			$Input = $COLOR_BLACK

		Case "clMaroon"
			$Input = $COLOR_MAROON

		Case "clGreen"
			$Input = $COLOR_GREEN

		Case "clOlive"
			$Input = $COLOR_OLIVE
			
		Case "clNavy"
			$Input = $COLOR_NAVY

		Case "clPurple"
			$Input = $COLOR_PURPLE

		Case "clTeal"
			$Input = $COLOR_TEAL

		Case "clGray"
			$Input = $COLOR_GRAY

		Case "clSilver"
			$Input = $COLOR_SILVER

		Case "clRed"
			$Input = $COLOR_RED

		Case "clLime"
			$Input = $COLOR_LIME

		Case "clYellow"
			$Input = $COLOR_YELLOW

		Case "clBlue"
			$Input = $COLOR_BLUE

		Case "clFuchsia"
			$Input = $COLOR_FUCHSIA

		Case "clAqua"
			$Input = $COLOR_AQUA

		Case "clWhite"
			$Input = $COLOR_WHITE

		Case "clMoneyGreen"
			$Input = $COLOR_MONEYGREEN

		Case "clSkyBlue"
			$Input = $COLOR_SKYBLUE

		Case "clCream"
			$Input = $COLOR_CREAM

		Case "clMedGray"
			$Input = $COLOR_MEDGRAY
			
		Case "clMedGray"
			$Input = $COLOR_MEDGRAY

		Case "clMedBlue"
			$Input = $COLOR_MEDBLUE
			
		Case "clActiveBorder"
			$Input = _WinAPI_GetSysColor($COLOR_ACTIVEBORDER)
			
		Case "clActiveCaption"
			$Input = _WinAPI_GetSysColor($COLOR_ACTIVECAPTION)

		Case "clAppWorkSpace"
			$Input = _WinAPI_GetSysColor($COLOR_APPWORKSPACE)

		Case "clBackground"
			$Input = _WinAPI_GetSysColor($COLOR_BACKGROUND)

		Case "clBtnFace"
			$Input = _WinAPI_GetSysColor($COLOR_BTNFACE)

		Case "clBtnHighlight"
			$Input = _WinAPI_GetSysColor($COLOR_BTNHIGHLIGHT)

		Case "clBtnShadow"
			$Input = _WinAPI_GetSysColor($COLOR_BTNSHADOW)
			
		Case "clBtnText"
			$Input = _WinAPI_GetSysColor($COLOR_BTNTEXT)

		Case "clCaptionText"
			$Input = _WinAPI_GetSysColor($COLOR_CAPTIONTEXT)

		Case "clDefault", "clNone"
			$Input = $COLOR_BLACK
			
		Case "clGradientActiveCaption"
			$Input = _WinAPI_GetSysColor($COLOR_GRADIENTINACTIVECAPTION)

		Case "clGradientInactiveCaption"
			$Input = _WinAPI_GetSysColor($COLOR_INACTIVECAPTION)

		Case "clGrayText"
			$Input = _WinAPI_GetSysColor($COLOR_GRAYTEXT)

		Case "clHighlight"
			$Input = _WinAPI_GetSysColor($COLOR_HIGHLIGHT)

		Case "clHighlightText"
			$Input = _WinAPI_GetSysColor($COLOR_HIGHLIGHTTEXT)

		Case "clHotLight"
			$Input = _WinAPI_GetSysColor($COLOR_HOTLIGHT)

		Case "clInactiveBorder"
			$Input = _WinAPI_GetSysColor($COLOR_INACTIVEBORDER)

		Case "clInactiveCaption"
			$Input = _WinAPI_GetSysColor($COLOR_INACTIVECAPTION)
			
		Case "clInactiveCaptionText"
			$Input = _WinAPI_GetSysColor($COLOR_INACTIVECAPTIONTEXT)
			
		Case "clInfoBk"
			$Input = _WinAPI_GetSysColor($COLOR_INFOBK)
			
		Case "clInfoText"
			$Input = _WinAPI_GetSysColor($COLOR_INFOTEXT)

		Case "clMenu"
			$Input = _WinAPI_GetSysColor($COLOR_MENU)

		Case "clMenuBar"
			$Input = _WinAPI_GetSysColor($COLOR_MENUBAR)

		Case "clMenuHighlight"
			$Input = _WinAPI_GetSysColor($COLOR_MENUHILIGHT)
			
		Case "clMenuText"
			$Input = _WinAPI_GetSysColor($COLOR_MENUTEXT)
			
		Case "clScrollBar"
			$Input = _WinAPI_GetSysColor($COLOR_SCROLLBAR)
			
		Case "cl3DDkShadow"
			$Input = _WinAPI_GetSysColor($COLOR_3DDKSHADOW)

		Case "cl3DLight"
			$Input = _WinAPI_GetSysColor($COLOR_3DLIGHT)

		Case "clWindow"
			$Input = _WinAPI_GetSysColor($COLOR_WINDOW)
			
		Case "clWindowFrame"
			$Input = _WinAPI_GetSysColor($COLOR_WINDOWFRAME)
			
		Case "clWindowText"
			$Input = _WinAPI_GetSysColor($COLOR_WINDOWTEXT)
			
	EndSwitch
	
	$Input = Hex($Input, 6)
	Return "0x" & $Input
EndFunc   ;==>_Get_ColorFromKXF


Func _Get_ResizingFromKXF($Input = "")
	If $Input = "" Then Return ""
	
	Local $Resizing = 0
	If StringInStr($Input, "DockAuto") Then $Resizing = $Resizing + $GUI_DOCKAUTO
	If StringInStr($Input, "DockLeft") Then $Resizing = $Resizing + $GUI_DOCKLEFT
	If StringInStr($Input, "DockRight") Then $Resizing = $Resizing + $GUI_DOCKRIGHT
	If StringInStr($Input, "DockTop") Then $Resizing = $Resizing + $GUI_DOCKTOP
	If StringInStr($Input, "DockBottom") Then $Resizing = $Resizing + $GUI_DOCKBOTTOM
	If StringInStr($Input, "DockHCenter") Then $Resizing = $Resizing + $GUI_DOCKHCENTER
	If StringInStr($Input, "DockVCenter") Then $Resizing = $Resizing + $GUI_DOCKVCENTER
	If StringInStr($Input, "DockWidth") Then $Resizing = $Resizing + $GUI_DOCKWIDTH
	If StringInStr($Input, "DockHeight") Then $Resizing = $Resizing + $GUI_DOCKHEIGHT
	
	Return $Resizing
EndFunc   ;==>_Get_ResizingFromKXF


Func _Get_FontAttributeFromKXF($Input = "")
	If $Input = "" Then Return ""
	
	Local $NewStyle = 0
	If StringInStr($Input, "fsItalic") Then $NewStyle = $NewStyle + $GUI_FONTITALIC
	If StringInStr($Input, "fsUnderline") Then $NewStyle = $NewStyle + $GUI_FONTUNDER
	If StringInStr($Input, "fsStrikeOut") Then $NewStyle = $NewStyle + $GUI_FONTSTRIKE
	
	Return $NewStyle
EndFunc   ;==>_Get_FontAttributeFromKXF

Func _Get_FontStyleFromKXF($Input = "")
	If $Input = "" Then Return ""
	
	Local $NewStyle = $FW_NORMAL
	If StringInStr($Input, "fsBold") Then $NewStyle = $FW_EXTRABOLD
	
	Return $NewStyle
EndFunc   ;==>_Get_FontStyleFromKXF

Func _Get_KXFConvertInt8($Input = "")
	If $Input = "" Then Return ""
	
	$Input = $Input * -0.75
	$Input = Round($Input, 0)

	Return $Input
EndFunc   ;==>_Get_KXFConvertInt8

Func _Return_Handle_with_Dollar($handle = "")
	If $handle = "" Then Return ""
	$handle = StringStripWS($handle, 3)
	$handle = StringReplace($handle, "$$", "")
	$handle = StringReplace($handle, "$$$", "")
	$handle = StringReplace($handle, "$$$$", "")
	If StringLeft($handle, 1) <> "$" Then
		Return "$" & $handle
	Else
		Return $handle
	EndIf
EndFunc   ;==>_Return_Handle_with_Dollar


Func _Get_StyleFromKXF($Input = "", $Type = "")
	If $Input = "" Then Return ""
	If $IgnoreStyle = "1" Then Return ""
	
	Local $NewStyle = ""
	
	If $Type = "button" Or $Type = "checkbox" Or $Type = "radio" Or $Type = "group" Then
		If BitAND($Input, $BS_LEFT) = $BS_LEFT Then $NewStyle = $NewStyle & "$BS_LEFT+"
		If BitAND($Input, $BS_RIGHT) = $BS_RIGHT Then $NewStyle = $NewStyle & "$BS_RIGHT+"
		If BitAND($Input, $BS_TOP) = $BS_TOP Then $NewStyle = $NewStyle & "$BS_TOP+"
		If BitAND($Input, $BS_CENTER) = $BS_CENTER Then $NewStyle = $NewStyle & "$BS_CENTER+"
		If BitAND($Input, $BS_DEFPUSHBUTTON) = $BS_DEFPUSHBUTTON And $Type = "button" Then $NewStyle = $NewStyle & "$BS_DEFPUSHBUTTON+"
		If BitAND($Input, $BS_MULTILINE) = $BS_MULTILINE Then $NewStyle = $NewStyle & "$BS_MULTILINE+"
		If BitAND($Input, $WS_BORDER) = $WS_BORDER Then $NewStyle = $NewStyle & "$WS_BORDER+"
		If BitAND($Input, $BS_VCENTER) = $BS_VCENTER Then $NewStyle = $NewStyle & "$BS_VCENTER+"
		If BitAND($Input, $BS_ICON) = $BS_ICON Then $NewStyle = $NewStyle & "$BS_ICON+"
		If BitAND($Input, $BS_BITMAP) = $BS_BITMAP Then $NewStyle = $NewStyle & "$BS_BITMAP+"
		If BitAND($Input, $BS_FLAT) = $BS_FLAT Then $NewStyle = $NewStyle & "$BS_FLAT+"
		If BitAND($Input, $BS_NOTIFY) = $BS_NOTIFY Then $NewStyle = $NewStyle & "$BS_NOTIFY+"
	EndIf
	
	If $Type = "checkbox" Or $Type = "radio" Then
		If BitAND($Input, $BS_RIGHTBUTTON) = $BS_RIGHTBUTTON Then $NewStyle = $NewStyle & "$BS_RIGHTBUTTON+"
		If BitAND($Input, $BS_AUTO3STATE) = $BS_AUTO3STATE Then $NewStyle = $NewStyle & "$BS_AUTO3STATE+"
		If BitAND($Input, $BS_AUTORADIOBUTTON) = $BS_AUTORADIOBUTTON Then $NewStyle = $NewStyle & "$BS_AUTORADIOBUTTON+"
		If BitAND($Input, $BS_PUSHLIKE) = $BS_PUSHLIKE Then $NewStyle = $NewStyle & "$BS_PUSHLIKE+"
	EndIf
	
	If $Type = "label" Or $Type = "icon" Or $Type = "image" Or $Type = "graphic" Then
		If BitAND($Input, $SS_LEFT) = $SS_LEFT Then $NewStyle = $NewStyle & "$SS_LEFT+"
		If BitAND($Input, $SS_RIGHT) = $SS_RIGHT Then $NewStyle = $NewStyle & "$SS_RIGHT+"
		If BitAND($Input, $SS_CENTER) = $SS_CENTER Then $NewStyle = $NewStyle & "$SS_CENTER+"
		If BitAND($Input, $SS_NOPREFIX) = $SS_NOPREFIX Then $NewStyle = $NewStyle & "$SS_NOPREFIX+"
		If BitAND($Input, $SS_LEFTNOWORDWRAP) = $SS_LEFTNOWORDWRAP Then $NewStyle = $NewStyle & "$SS_LEFTNOWORDWRAP+"
		If BitAND($Input, $SS_RIGHTJUST) = $SS_RIGHTJUST Then $NewStyle = $NewStyle & "$SS_RIGHTJUST+"
		If BitAND($Input, $SS_BLACKFRAME) = $SS_BLACKFRAME Then $NewStyle = $NewStyle & "$SS_BLACKFRAME+"
		If BitAND($Input, $SS_BLACKRECT) = $SS_BLACKRECT Then $NewStyle = $NewStyle & "$SS_BLACKRECT+"
		If BitAND($Input, $SS_CENTERIMAGE) = $SS_CENTERIMAGE Then $NewStyle = $NewStyle & "$SS_CENTERIMAGE+"
		If BitAND($Input, $SS_GRAYFRAME) = $SS_GRAYFRAME Then $NewStyle = $NewStyle & "$SS_GRAYFRAME+"
		If BitAND($Input, $SS_ETCHEDHORZ) = $SS_ETCHEDHORZ Then $NewStyle = $NewStyle & "$SS_ETCHEDHORZ+"
		If BitAND($Input, $SS_ETCHEDVERT) = $SS_ETCHEDVERT Then $NewStyle = $NewStyle & "$SS_ETCHEDVERT+"
		If BitAND($Input, $SS_GRAYRECT) = $SS_GRAYRECT Then $NewStyle = $NewStyle & "$SS_GRAYRECT+"
		If BitAND($Input, $SS_NOTIFY) = $SS_NOTIFY Then $NewStyle = $NewStyle & "$SS_NOTIFY+"
		If BitAND($Input, $SS_SIMPLE) = $SS_SIMPLE Then $NewStyle = $NewStyle & "$SS_SIMPLE+"
		If BitAND($Input, $SS_SUNKEN) = $SS_SUNKEN Then $NewStyle = $NewStyle & "$SS_SUNKEN+"
		If BitAND($Input, $SS_WHITEFRAME) = $SS_WHITEFRAME Then $NewStyle = $NewStyle & "$SS_WHITEFRAME+"
		If BitAND($Input, $SS_WHITERECT) = $SS_WHITERECT Then $NewStyle = $NewStyle & "$SS_WHITERECT+"
		If BitAND($Input, $WS_CLIPSIBLINGS) = $WS_CLIPSIBLINGS Then $NewStyle = $NewStyle & "$WS_CLIPSIBLINGS+"
	EndIf

	If $Type = "slider" Then
		If BitAND($Input, $TBS_AUTOTICKS) = $TBS_AUTOTICKS Then $NewStyle = $NewStyle & "$TBS_AUTOTICKS+"
		If BitAND($Input, $TBS_BOTH) = $TBS_BOTH Then $NewStyle = $NewStyle & "$TBS_BOTH+"
		If BitAND($Input, $TBS_BOTTOM) = $TBS_BOTTOM Then $NewStyle = $NewStyle & "$TBS_BOTTOM+"
		If BitAND($Input, $TBS_HORZ) = $TBS_HORZ Then $NewStyle = $NewStyle & "$TBS_HORZ+"
		If BitAND($Input, $TBS_VERT) = $TBS_VERT Then $NewStyle = $NewStyle & "$TBS_VERT+"
		If BitAND($Input, $TBS_NOTHUMB) = $TBS_NOTHUMB Then $NewStyle = $NewStyle & "$TBS_NOTHUMB+"
		If BitAND($Input, $TBS_NOTICKS) = $TBS_NOTICKS Then $NewStyle = $NewStyle & "$TBS_NOTICKS+"
		If BitAND($Input, $TBS_LEFT) = $TBS_LEFT Then $NewStyle = $NewStyle & "$TBS_LEFT+"
		If BitAND($Input, $TBS_RIGHT) = $TBS_RIGHT Then $NewStyle = $NewStyle & "$TBS_RIGHT+"
		If BitAND($Input, $TBS_TOP) = $TBS_TOP Then $NewStyle = $NewStyle & "$TBS_TOP+"
	EndIf

	If $Type = "listview" Then
		If BitAND($Input, $LVS_ICON) = $LVS_ICON Then $NewStyle = $NewStyle & "$LVS_ICON+"
		If BitAND($Input, $LVS_REPORT) = $LVS_REPORT Then $NewStyle = $NewStyle & "$LVS_REPORT+"
		If BitAND($Input, $LVS_SMALLICON) = $LVS_SMALLICON Then $NewStyle = $NewStyle & "$LVS_SMALLICON+"
		If BitAND($Input, $LVS_LIST) = $LVS_LIST Then $NewStyle = $NewStyle & "$LVS_LIST+"
		If BitAND($Input, $LVS_NOCOLUMNHEADER) = $LVS_NOCOLUMNHEADER Then $NewStyle = $NewStyle & "$LVS_NOCOLUMNHEADER+"
		If BitAND($Input, $LVS_NOSORTHEADER) = $LVS_NOSORTHEADER Then $NewStyle = $NewStyle & "$LVS_NOSORTHEADER+"
		If BitAND($Input, $LVS_SINGLESEL) = $LVS_SINGLESEL Then $NewStyle = $NewStyle & "$LVS_SINGLESEL+"
		If BitAND($Input, $LVS_SHOWSELALWAYS) = $LVS_SHOWSELALWAYS Then $NewStyle = $NewStyle & "$LVS_SHOWSELALWAYS+"
		If BitAND($Input, $LVS_SORTASCENDING) = $LVS_SORTASCENDING Then $NewStyle = $NewStyle & "$LVS_SORTASCENDING+"
		If BitAND($Input, $LVS_SORTDESCENDING) = $LVS_SORTDESCENDING Then $NewStyle = $NewStyle & "$LVS_SORTDESCENDING+"
		If BitAND($Input, $LVS_NOLABELWRAP) = $LVS_NOLABELWRAP Then $NewStyle = $NewStyle & "$LVS_NOLABELWRAP+"
	EndIf
	
	If $Type = "progress" Then
		If BitAND($Input, $PBS_SMOOTH) = $PBS_SMOOTH Then $NewStyle = $NewStyle & "$PBS_SMOOTH+"
		If BitAND($Input, $PBS_VERTICAL) = $PBS_VERTICAL Then $NewStyle = $NewStyle & "$PBS_VERTICAL+"
		If BitAND($Input, $PBS_MARQUEE) = $PBS_MARQUEE Then $NewStyle = $NewStyle & "$PBS_MARQUEE+"
		If BitAND($Input, $WS_BORDER) = $WS_BORDER Then $NewStyle = $NewStyle & "$WS_BORDER+"
	EndIf
	
	If $Type = "updown" Then
		If BitAND($Input, $UDS_ALIGNLEFT) = $UDS_ALIGNLEFT Then $NewStyle = $NewStyle & "$UDS_ALIGNLEFT+"
		If BitAND($Input, $UDS_ALIGNRIGHT) = $UDS_ALIGNRIGHT Then $NewStyle = $NewStyle & "$UDS_ALIGNRIGHT+"
		If BitAND($Input, $UDS_ARROWKEYS) = $UDS_ARROWKEYS Then $NewStyle = $NewStyle & "$UDS_ARROWKEYS+"
		If BitAND($Input, $UDS_HORZ) = $UDS_HORZ Then $NewStyle = $NewStyle & "$UDS_HORZ+"
		If BitAND($Input, $UDS_NOTHOUSANDS) = $UDS_NOTHOUSANDS Then $NewStyle = $NewStyle & "$UDS_NOTHOUSANDS+"
		If BitAND($Input, $UDS_WRAP) = $UDS_WRAP Then $NewStyle = $NewStyle & "$UDS_WRAP+"
		If BitAND($Input, $ES_NUMBER) = $ES_NUMBER Then $NewStyle = $NewStyle & "$ES_NUMBER+"
	EndIf

	If $Type = "input" Or $Type = "edit" Or $Type = "richedit" Then
		If BitAND($Input, $ES_AUTOHSCROLL) = $ES_AUTOHSCROLL Then $NewStyle = $NewStyle & "$ES_AUTOHSCROLL+"
		If BitAND($Input, $ES_AUTOVSCROLL) = $ES_AUTOVSCROLL Then $NewStyle = $NewStyle & "$ES_AUTOVSCROLL+"
		If BitAND($Input, $ES_CENTER) = $ES_CENTER Then $NewStyle = $NewStyle & "$ES_CENTER+"
		If BitAND($Input, $ES_PASSWORD) = $ES_PASSWORD Then $NewStyle = $NewStyle & "$ES_PASSWORD+"
		If BitAND($Input, $ES_READONLY) = $ES_READONLY Then $NewStyle = $NewStyle & "$ES_READONLY+"
		If BitAND($Input, $ES_LOWERCASE) = $ES_LOWERCASE Then $NewStyle = $NewStyle & "$ES_LOWERCASE+"
		If BitAND($Input, $ES_NOHIDESEL) = $ES_NOHIDESEL Then $NewStyle = $NewStyle & "$ES_NOHIDESEL+"
		If BitAND($Input, $ES_NUMBER) = $ES_NUMBER Then $NewStyle = $NewStyle & "$ES_NUMBER+"
		If BitAND($Input, $ES_OEMCONVERT) = $ES_OEMCONVERT Then $NewStyle = $NewStyle & "$ES_OEMCONVERT+"
		If BitAND($Input, $ES_MULTILINE) = $ES_MULTILINE Then $NewStyle = $NewStyle & "$ES_MULTILINE+"
		If BitAND($Input, $ES_RIGHT) = $ES_RIGHT Then $NewStyle = $NewStyle & "$ES_RIGHT+"
		If BitAND($Input, $ES_UPPERCASE) = $ES_UPPERCASE Then $NewStyle = $NewStyle & "$ES_UPPERCASE+"
		If BitAND($Input, $ES_WANTRETURN) = $ES_WANTRETURN Then $NewStyle = $NewStyle & "$ES_WANTRETURN+"
		If BitAND($Input, $WS_VSCROLL) = $WS_VSCROLL Then $NewStyle = $NewStyle & "$WS_VSCROLL+"
		If BitAND($Input, $WS_HSCROLL) = $WS_HSCROLL Then $NewStyle = $NewStyle & "$WS_HSCROLL+"
	EndIf

	If $Type = "combo" Then
		If BitAND($Input, $CBS_AUTOHSCROLL) = $CBS_AUTOHSCROLL Then $NewStyle = $NewStyle & "$CBS_AUTOHSCROLL+"
		If BitAND($Input, $CBS_DISABLENOSCROLL) = $CBS_DISABLENOSCROLL Then $NewStyle = $NewStyle & "$CBS_DISABLENOSCROLL+"
		If BitAND($Input, $CBS_DROPDOWN) = $CBS_DROPDOWN Then $NewStyle = $NewStyle & "$CBS_DROPDOWN+"
		If BitAND($Input, $CBS_DROPDOWNLIST) = $CBS_DROPDOWNLIST Then $NewStyle = $NewStyle & "$CBS_DROPDOWNLIST+"
		If BitAND($Input, $CBS_NOINTEGRALHEIGHT) = $CBS_NOINTEGRALHEIGHT Then $NewStyle = $NewStyle & "$CBS_NOINTEGRALHEIGHT+"
		If BitAND($Input, $CBS_OEMCONVERT) = $CBS_OEMCONVERT Then $NewStyle = $NewStyle & "$CBS_OEMCONVERT+"
		If BitAND($Input, $CBS_SIMPLE) = $CBS_SIMPLE Then $NewStyle = $NewStyle & "$CBS_SIMPLE+"
		If BitAND($Input, $CBS_SORT) = $CBS_SORT Then $NewStyle = $NewStyle & "$CBS_SORT+"
		If BitAND($Input, $CBS_UPPERCASE) = $CBS_UPPERCASE Then $NewStyle = $NewStyle & "$CBS_UPPERCASE+"
		If BitAND($Input, $WS_VSCROLL) = $WS_VSCROLL Then $NewStyle = $NewStyle & "$WS_VSCROLL+"
	EndIf

	If $Type = "listbox" Then
		If BitAND($Input, $LBS_DISABLENOSCROLL) = $LBS_DISABLENOSCROLL Then $NewStyle = $NewStyle & "$LBS_DISABLENOSCROLL+"
		If BitAND($Input, $LBS_NOINTEGRALHEIGHT) = $LBS_NOINTEGRALHEIGHT Then $NewStyle = $NewStyle & "$LBS_NOINTEGRALHEIGHT+"
		If BitAND($Input, $LBS_NOSEL) = $LBS_NOSEL Then $NewStyle = $NewStyle & "$LBS_NOSEL+"
		If BitAND($Input, $LBS_NOTIFY) = $LBS_NOTIFY Then $NewStyle = $NewStyle & "$LBS_NOTIFY+"
		If BitAND($Input, $LBS_SORT) = $LBS_SORT Then $NewStyle = $NewStyle & "$LBS_SORT+"
		If BitAND($Input, $LBS_STANDARD) = $LBS_STANDARD Then $NewStyle = $NewStyle & "$LBS_STANDARD+"
		If BitAND($Input, $LBS_USETABSTOPS) = $LBS_USETABSTOPS Then $NewStyle = $NewStyle & "$LBS_USETABSTOPS+"
	EndIf

	If $Type = "listbox" Then
		If BitAND($Input, $LBS_DISABLENOSCROLL) = $LBS_DISABLENOSCROLL Then $NewStyle = $NewStyle & "$LBS_DISABLENOSCROLL+"
		If BitAND($Input, $LBS_NOINTEGRALHEIGHT) = $LBS_NOINTEGRALHEIGHT Then $NewStyle = $NewStyle & "$LBS_NOINTEGRALHEIGHT+"
		If BitAND($Input, $LBS_NOSEL) = $LBS_NOSEL Then $NewStyle = $NewStyle & "$LBS_NOSEL+"
		If BitAND($Input, $LBS_NOTIFY) = $LBS_NOTIFY Then $NewStyle = $NewStyle & "$LBS_NOTIFY+"
		If BitAND($Input, $LBS_SORT) = $LBS_SORT Then $NewStyle = $NewStyle & "$LBS_SORT+"
		If BitAND($Input, $LBS_STANDARD) = $LBS_STANDARD Then $NewStyle = $NewStyle & "$LBS_STANDARD+"
		If BitAND($Input, $LBS_USETABSTOPS) = $LBS_USETABSTOPS Then $NewStyle = $NewStyle & "$LBS_USETABSTOPS+"
	EndIf

	If $Type = "treeview" Then
		If BitAND($Input, $TVS_HASBUTTONS) = $TVS_HASBUTTONS Then $NewStyle = $NewStyle & "$TVS_HASBUTTONS+"
		If BitAND($Input, $TVS_HASLINES) = $TVS_HASLINES Then $NewStyle = $NewStyle & "$TVS_HASLINES+"
		If BitAND($Input, $TVS_LINESATROOT) = $TVS_LINESATROOT Then $NewStyle = $NewStyle & "$TVS_LINESATROOT+"
		If BitAND($Input, $TVS_DISABLEDRAGDROP) = $TVS_DISABLEDRAGDROP Then $NewStyle = $NewStyle & "$TVS_DISABLEDRAGDROP+"
		If BitAND($Input, $TVS_SHOWSELALWAYS) = $TVS_SHOWSELALWAYS Then $NewStyle = $NewStyle & "$TVS_SHOWSELALWAYS+"
		If BitAND($Input, $TVS_RTLREADING) = $TVS_RTLREADING Then $NewStyle = $NewStyle & "$TVS_RTLREADING+"
		If BitAND($Input, $TVS_NOTOOLTIPS) = $TVS_NOTOOLTIPS Then $NewStyle = $NewStyle & "$TVS_NOTOOLTIPS+"
		If BitAND($Input, $TVS_CHECKBOXES) = $TVS_CHECKBOXES Then $NewStyle = $NewStyle & "$TVS_CHECKBOXES+"
		If BitAND($Input, $TVS_TRACKSELECT) = $TVS_TRACKSELECT Then $NewStyle = $NewStyle & "$TVS_TRACKSELECT+"
		If BitAND($Input, $TVS_SINGLEEXPAND) = $TVS_SINGLEEXPAND Then $NewStyle = $NewStyle & "$TVS_SINGLEEXPAND+"
		If BitAND($Input, $TVS_FULLROWSELECT) = $TVS_FULLROWSELECT Then $NewStyle = $NewStyle & "$TVS_FULLROWSELECT+"
		If BitAND($Input, $TVS_NOSCROLL) = $TVS_NOSCROLL Then $NewStyle = $NewStyle & "$TVS_NOSCROLL+"
		If BitAND($Input, $TVS_NONEVENHEIGHT) = $TVS_NONEVENHEIGHT Then $NewStyle = $NewStyle & "$TVS_NONEVENHEIGHT+"
	EndIf

	If $Type = "tab" Then
		If BitAND($Input, $TCS_SCROLLOPPOSITE) = $TCS_SCROLLOPPOSITE Then $NewStyle = $NewStyle & "$TCS_SCROLLOPPOSITE+"
		If BitAND($Input, $TCS_BOTTOM) = $TCS_BOTTOM Then $NewStyle = $NewStyle & "$TCS_BOTTOM+"
;~ 			If BitAND($Input, $TCS_RIGHT) = $TCS_RIGHT Then $NewStyle = $NewStyle & "$TCS_RIGHT+"
		If BitAND($Input, $TCS_TOOLTIPS) = $TCS_TOOLTIPS Then $NewStyle = $NewStyle & "$TCS_TOOLTIPS+"
		If BitAND($Input, $TCS_MULTISELECT) = $TCS_MULTISELECT Then $NewStyle = $NewStyle & "$TCS_MULTISELECT+"
		If BitAND($Input, $TCS_FLATBUTTONS) = $TCS_FLATBUTTONS Then $NewStyle = $NewStyle & "$TCS_FLATBUTTONS+"
		If BitAND($Input, $TCS_FORCEICONLEFT) = $TCS_FORCEICONLEFT Then $NewStyle = $NewStyle & "$TCS_FORCEICONLEFT+"
		If BitAND($Input, $TCS_FORCELABELLEFT) = $TCS_FORCELABELLEFT Then $NewStyle = $NewStyle & "$TCS_FORCELABELLEFT+"
		If BitAND($Input, $TCS_HOTTRACK) = $TCS_HOTTRACK Then $NewStyle = $NewStyle & "$TCS_HOTTRACK+"
		If BitAND($Input, $TCS_VERTICAL) = $TCS_VERTICAL Then $NewStyle = $NewStyle & "$TCS_VERTICAL+"
;~ 			If BitAND($Input, $TCS_BUTTONS) = $TCS_BUTTONS Then $NewStyle = $NewStyle & "$TCS_BUTTONS+"
		If BitAND($Input, $TCS_MULTILINE) = $TCS_MULTILINE Then $NewStyle = $NewStyle & "$TCS_MULTILINE+"
		If BitAND($Input, $TCS_RIGHTJUSTIFY) = $TCS_RIGHTJUSTIFY Then $NewStyle = $NewStyle & "$TCS_RIGHTJUSTIFY+"
		If BitAND($Input, $TCS_FIXEDWIDTH) = $TCS_FIXEDWIDTH Then $NewStyle = $NewStyle & "$TCS_FIXEDWIDTH+"
		If BitAND($Input, $TCS_FOCUSONBUTTONDOWN) = $TCS_FOCUSONBUTTONDOWN Then $NewStyle = $NewStyle & "$TCS_FOCUSONBUTTONDOWN+"
		If BitAND($Input, $TCS_OWNERDRAWFIXED) = $TCS_OWNERDRAWFIXED Then $NewStyle = $NewStyle & "$TCS_OWNERDRAWFIXED+"
		If BitAND($Input, $TCS_FOCUSNEVER) = $TCS_FOCUSNEVER Then $NewStyle = $NewStyle & "$TCS_FOCUSNEVER+"
	EndIf
	
	If $Type = "date" Then
		If BitAND($Input, $DTS_UPDOWN) = $DTS_UPDOWN Then $NewStyle = $NewStyle & "$DTS_UPDOWN+"
		If BitAND($Input, $DTS_SHOWNONE) = $DTS_SHOWNONE Then $NewStyle = $NewStyle & "$DTS_SHOWNONE+"
		If BitAND($Input, $DTS_LONGDATEFORMAT) = $DTS_LONGDATEFORMAT Then $NewStyle = $NewStyle & "$DTS_LONGDATEFORMAT+"
		If BitAND($Input, $DTS_TIMEFORMAT) = $DTS_TIMEFORMAT Then $NewStyle = $NewStyle & "$DTS_TIMEFORMAT+"
		If BitAND($Input, $DTS_RIGHTALIGN) = $DTS_RIGHTALIGN Then $NewStyle = $NewStyle & "$DTS_RIGHTALIGN+"
		If BitAND($Input, $DTS_SHORTDATEFORMAT) = $DTS_SHORTDATEFORMAT Then $NewStyle = $NewStyle & "$DTS_SHORTDATEFORMAT+"
	EndIf

	If $Type = "calendar" Then
		If BitAND($Input, $MCS_NOTODAY) = $MCS_NOTODAY Then $NewStyle = $NewStyle & "$MCS_NOTODAY+"
		If BitAND($Input, $MCS_NOTODAYCIRCLE) = $MCS_NOTODAYCIRCLE Then $NewStyle = $NewStyle & "$MCS_NOTODAYCIRCLE+"
		If BitAND($Input, $MCS_WEEKNUMBERS) = $MCS_WEEKNUMBERS Then $NewStyle = $NewStyle & "$MCS_WEEKNUMBERS+"
	EndIf

	If $Type = "gui" Then
		If BitAND($Input, $WS_POPUP) = $WS_POPUP Then $NewStyle = $NewStyle & "$WS_POPUP+"
		If BitAND($Input, $WS_CAPTION) = $WS_CAPTION Then $NewStyle = $NewStyle & "$WS_CAPTION+"
		If BitAND($Input, $WS_DISABLED) = $WS_DISABLED Then $NewStyle = $NewStyle & "$WS_DISABLED+"
		If BitAND($Input, $WS_SIZEBOX) = $WS_SIZEBOX Then $NewStyle = $NewStyle & "$WS_SIZEBOX+"
		If BitAND($Input, $WS_SYSMENU) = $WS_SYSMENU Then $NewStyle = $NewStyle & "$WS_SYSMENU+"
		If BitAND($Input, $WS_CHILD) = $WS_CHILD Then $NewStyle = $NewStyle & "$WS_CHILD+"
		If BitAND($Input, $WS_CLIPCHILDREN) = $WS_CLIPCHILDREN Then $NewStyle = $NewStyle & "$WS_CLIPCHILDREN+"
		If BitAND($Input, $WS_EX_CLIENTEDGE) = $WS_EX_CLIENTEDGE Then $NewStyle = $NewStyle & "$WS_EX_CLIENTEDGE+"
		If BitAND($Input, $WS_DLGFRAME) = $WS_DLGFRAME Then $NewStyle = $NewStyle & "$WS_DLGFRAME+"
		If BitAND($Input, $WS_BORDER) = $WS_BORDER Then $NewStyle = $NewStyle & "$WS_BORDER+"
		If BitAND($Input, $WS_HSCROLL) = $WS_HSCROLL Then $NewStyle = $NewStyle & "$WS_HSCROLL+"
		If BitAND($Input, $WS_VSCROLL) = $WS_VSCROLL Then $NewStyle = $NewStyle & "$WS_VSCROLL+"
		If BitAND($Input, $WS_MAXIMIZE) = $WS_MAXIMIZE Then $NewStyle = $NewStyle & "$WS_MAXIMIZE+"
		If BitAND($Input, $WS_MAXIMIZEBOX) = $WS_MAXIMIZEBOX Then $NewStyle = $NewStyle & "$WS_MAXIMIZEBOX+"
		If BitAND($Input, $WS_MINIMIZE) = $WS_MINIMIZE Then $NewStyle = $NewStyle & "$WS_MINIMIZE+"
		If BitAND($Input, $WS_MINIMIZEBOX) = $WS_MINIMIZEBOX Then $NewStyle = $NewStyle & "$WS_MINIMIZEBOX+"
		If BitAND($Input, $WS_OVERLAPPED) = $WS_OVERLAPPED Then $NewStyle = $NewStyle & "$WS_OVERLAPPED+"
		If BitAND($Input, $WS_OVERLAPPEDWINDOW) = $WS_OVERLAPPEDWINDOW Then $NewStyle = $NewStyle & "$WS_OVERLAPPEDWINDOW+"
		If BitAND($Input, $WS_POPUPWINDOW) = $WS_POPUPWINDOW Then $NewStyle = $NewStyle & "$WS_POPUPWINDOW+"
		If BitAND($Input, $WS_THICKFRAME) = $WS_THICKFRAME Then $NewStyle = $NewStyle & "$WS_THICKFRAME+"
		If BitAND($Input, $WS_VISIBLE) = $WS_VISIBLE Then $NewStyle = $NewStyle & "$WS_VISIBLE+"
		If BitAND($Input, $DS_MODALFRAME) = $DS_MODALFRAME Then $NewStyle = $NewStyle & "$DS_MODALFRAME+"
		If BitAND($Input, $DS_SETFOREGROUND) = $DS_SETFOREGROUND Then $NewStyle = $NewStyle & "$DS_SETFOREGROUND+"
		If BitAND($Input, $DS_CONTEXTHELP) = $DS_CONTEXTHELP Then $NewStyle = $NewStyle & "$DS_CONTEXTHELP+"
	EndIf
	
	If StringRight($NewStyle, 1) = "+" Then $NewStyle = StringTrimRight($NewStyle, 1)
	Return $NewStyle
EndFunc   ;==>_Get_StyleFromKXF


Func _Get_ExStyleFromKXF($Input = "", $Type = "")
	If $Input = "" Then Return ""
	If $IgnoreExStyle = "1" Then Return ""
	
	Local $NewStyle = ""
	
	If $Type = "gui" Then
		If BitAND($Input, $WS_EX_ACCEPTFILES) = $WS_EX_ACCEPTFILES Then $NewStyle = $NewStyle & "$WS_EX_ACCEPTFILES+"
		If BitAND($Input, $WS_EX_MDICHILD) = $WS_EX_MDICHILD Then $NewStyle = $NewStyle & "$WS_EX_MDICHILD+"
		If BitAND($Input, $WS_EX_APPWINDOW) = $WS_EX_APPWINDOW Then $NewStyle = $NewStyle & "$WS_EX_APPWINDOW+"
		If BitAND($Input, $WS_EX_TOPMOST) = $WS_EX_TOPMOST Then $NewStyle = $NewStyle & "$WS_EX_TOPMOST+"
		If BitAND($Input, $WS_EX_COMPOSITED) = $WS_EX_COMPOSITED Then $NewStyle = $NewStyle & "$WS_EX_COMPOSITED+"
		If BitAND($Input, $WS_EX_CLIENTEDGE) = $WS_EX_CLIENTEDGE Then $NewStyle = $NewStyle & "$WS_EX_CLIENTEDGE+"
		If BitAND($Input, $WS_EX_TOOLWINDOW) = $WS_EX_TOOLWINDOW Then $NewStyle = $NewStyle & "$WS_EX_TOOLWINDOW+"
		If BitAND($Input, $WS_EX_LAYERED) = $WS_EX_LAYERED Then $NewStyle = $NewStyle & "$WS_EX_LAYERED+"
		If BitAND($Input, $WS_EX_WINDOWEDGE) = $WS_EX_WINDOWEDGE Then $NewStyle = $NewStyle & "$WS_EX_WINDOWEDGE+"
		If BitAND($Input, $WS_EX_CONTEXTHELP) = $WS_EX_CONTEXTHELP Then $NewStyle = $NewStyle & "$WS_EX_CONTEXTHELP+"
		If BitAND($Input, $WS_EX_DLGMODALFRAME) = $WS_EX_DLGMODALFRAME Then $NewStyle = $NewStyle & "$WS_EX_DLGMODALFRAME+"
		If BitAND($Input, $WS_EX_OVERLAPPEDWINDOW) = $WS_EX_OVERLAPPEDWINDOW Then $NewStyle = $NewStyle & "$WS_EX_OVERLAPPEDWINDOW+"
		If BitAND($Input, $WS_EX_STATICEDGE) = $WS_EX_STATICEDGE Then $NewStyle = $NewStyle & "$WS_EX_STATICEDGE+"
		If BitAND($Input, $WS_EX_TRANSPARENT) = $WS_EX_TRANSPARENT Then $NewStyle = $NewStyle & "$WS_EX_TRANSPARENT+"
		If BitAND($Input, $WS_EX_LAYOUTRTL) = $WS_EX_LAYOUTRTL Then $NewStyle = $NewStyle & "$WS_EX_LAYOUTRTL+"
		If BitAND($Input, $GUI_WS_EX_PARENTDRAG) = $GUI_WS_EX_PARENTDRAG Then $NewStyle = $NewStyle & "$GUI_WS_EX_PARENTDRAG+"
	EndIf
	
	If $Type = "listview" Then
		If BitAND($Input, $LVS_EX_FULLROWSELECT) = $LVS_EX_FULLROWSELECT Then $NewStyle = $NewStyle & "$LVS_EX_FULLROWSELECT+"
		If BitAND($Input, $LVS_EX_GRIDLINES) = $LVS_EX_GRIDLINES Then $NewStyle = $NewStyle & "$LVS_EX_GRIDLINES+"
		If BitAND($Input, $LVS_EX_HEADERDRAGDROP) = $LVS_EX_HEADERDRAGDROP Then $NewStyle = $NewStyle & "$LVS_EX_HEADERDRAGDROP+"
		If BitAND($Input, $LVS_EX_TRACKSELECT) = $LVS_EX_TRACKSELECT Then $NewStyle = $NewStyle & "$LVS_EX_TRACKSELECT+"
		If BitAND($Input, $LVS_EX_CHECKBOXES) = $LVS_EX_CHECKBOXES Then $NewStyle = $NewStyle & "$LVS_EX_CHECKBOXES+"
		If BitAND($Input, $LVS_EX_BORDERSELECT) = $LVS_EX_BORDERSELECT Then $NewStyle = $NewStyle & "$LVS_EX_BORDERSELECT+"
		If BitAND($Input, $LVS_EX_DOUBLEBUFFER) = $LVS_EX_DOUBLEBUFFER Then $NewStyle = $NewStyle & "$LVS_EX_DOUBLEBUFFER+"
		If BitAND($Input, $LVS_EX_FLATSB) = $LVS_EX_FLATSB Then $NewStyle = $NewStyle & "$LVS_EX_FLATSB+"
		If BitAND($Input, $LVS_EX_MULTIWORKAREAS) = $LVS_EX_MULTIWORKAREAS Then $NewStyle = $NewStyle & "$LVS_EX_MULTIWORKAREAS+"
		If BitAND($Input, $LVS_EX_SNAPTOGRID) = $LVS_EX_SNAPTOGRID Then $NewStyle = $NewStyle & "$LVS_EX_SNAPTOGRID+"
		If BitAND($Input, $LVS_EX_SUBITEMIMAGES) = $LVS_EX_SUBITEMIMAGES Then $NewStyle = $NewStyle & "$LVS_EX_SUBITEMIMAGES+"
		If BitAND($Input, $LVS_EX_INFOTIP) = $LVS_EX_INFOTIP Then $NewStyle = $NewStyle & "$LVS_EX_INFOTIP+"
	EndIf

	If $Type <> "menu" And $Type <> "com" And $Type <> "gui" Then
		If BitAND($Input, $WS_EX_CLIENTEDGE) = $WS_EX_CLIENTEDGE Then $NewStyle = $NewStyle & "$WS_EX_CLIENTEDGE+"
		If BitAND($Input, $WS_EX_STATICEDGE) = $WS_EX_STATICEDGE Then $NewStyle = $NewStyle & "$WS_EX_STATICEDGE+"
		If BitAND($Input, $WS_EX_ACCEPTFILES) = $WS_EX_ACCEPTFILES Then $NewStyle = $NewStyle & "$WS_EX_ACCEPTFILES+"
		If BitAND($Input, $WS_EX_TRANSPARENT) = $WS_EX_TRANSPARENT Then $NewStyle = $NewStyle & "$WS_EX_TRANSPARENT+"
		If ($Type = "image" Or $Type = "label") And BitAND($Input, $GUI_WS_EX_PARENTDRAG) = $GUI_WS_EX_PARENTDRAG Then $NewStyle = $NewStyle & "$GUI_WS_EX_PARENTDRAG+"

	EndIf
	
	If StringRight($NewStyle, 1) = "+" Then $NewStyle = StringTrimRight($NewStyle, 1)
	Return $NewStyle
EndFunc   ;==>_Get_ExStyleFromKXF


;DPI Func
Func _GetDPI()
	Local $hDC = _WinAPI_GetDC(0)
	Local $DPI = _WinAPI_GetDeviceCaps($hDC, 90)
	_WinAPI_ReleaseDC(0, $hDC)

	Select
		Case $DPI = 0
			$DPI = 1
		Case $DPI < 84
			$DPI /= 105
		Case $DPI < 121
			$DPI /= 96
		Case $DPI < 145
			$DPI /= 96
		Case Else
			$DPI /= 96
	EndSelect

	Return Round($DPI, 2)
EndFunc   ;==>_GetDPI

; #FUNCTION# ====================================================================================================================
; Name ..........: _Fenster_Resizen_und_zentrieren
; Description ...:
; Syntax ........: _Fenster_Resizen_und_zentrieren($win, $txt [, $width=Default [, $height=Default]])
; Parameters ....: $win                 - An unknown value.
;                  $txt                 - A dll struct value.
;                  $width               - [optional] An AutoIt controlID. Default is Default.
;                  $height              - [optional] A handle value. Default is Default.
; Return values .: None
; Author ........: Christian Faderl
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Fenster_Resizen_und_zentrieren($win, $txt, $width = Default, $height = Default)
	Local $size = WinGetClientSize($win, $txt)
	If Not ($width = Default) Then $size[0] = $width
	If Not ($height = Default) Then $size[1] = $height
	Local $x = (@DesktopWidth / 2) - ($size[0] / 2)
	Local $y = (@DesktopHeight / 2) - ($size[1] / 2)
	If $x < 0 Then $x = 0
	If $y < 0 Then $y = 0
	Return WinMove($win, $txt, $x, $y, $size[0], $size[1]) ; second winmove
EndFunc   ;==>_Fenster_Resizen_und_zentrieren


Func _Control_set_DPI_Scaling($handle = "", $no_resize = False)
	If $handle = "" Then Return

	If $DPI == 1 Then Return ;Bei 100% gibt´s nichts zu tun
	If IsHWnd($handle) Then

		$fenster_positionen = WinGetPos($handle)
		$fenster_ClientSize = WinGetClientSize($handle)

		If IsArray($fenster_positionen) And IsArray($fenster_ClientSize) Then

			$Client_size_dif_Width = $fenster_positionen[2] - $fenster_ClientSize[0]
			$Client_size_dif_height = $fenster_positionen[3] - $fenster_ClientSize[1]

			_Fenster_Resizen_und_zentrieren($handle, "", ($fenster_ClientSize[0] * $DPI) + $Client_size_dif_Width, ($fenster_ClientSize[1] * $DPI) + $Client_size_dif_height)

		EndIf
	Else
		$handle = GUICtrlGetHandle($handle)
		$control_positionen = ControlGetPos($handle, "", $handle)
		If IsArray($control_positionen) Then
			If $no_resize Then
				GUICtrlSetPos(_WinAPI_GetDlgCtrlID($handle), $control_positionen[0] * $DPI, $control_positionen[1] * $DPI)
			Else
				GUICtrlSetPos(_WinAPI_GetDlgCtrlID($handle), $control_positionen[0] * $DPI, $control_positionen[1] * $DPI, $control_positionen[2] * $DPI, $control_positionen[3] * $DPI)
			EndIf

		EndIf

	EndIf
EndFunc   ;==>_Control_set_DPI_Scaling


Func _GUISetIcon($hHandle, $sFile, $iName)
	;Edit by isi360
	Return _SendMessage($hHandle, $WM_SETICON, 1, _WinAPI_ShellExtractIcon($sFile, $iName, 16, 16))
EndFunc   ;==>_GUISetIcon

Func Button_AddIcon($nID, $sIconFile, $nIconID, $nAlign)
;~ 	$sIconFile = $smallIconsdll
	If $DPI > 1.99 Then
		Local $hIL = ImageList_Create(24, 24, BitOR($ILC_MASK, $ILC_COLOR32), 0, 1) ;Use bigger icons over 200 % dpi scaling
	Else
		Local $hIL = ImageList_Create(16, 16, BitOR($ILC_MASK, $ILC_COLOR32), 0, 1)
	EndIf
	Local $stIcon = DllStructCreate("int")
	ExtractIconEx($sIconFile, $nIconID, DllStructGetPtr($stIcon), 0, 1)
	ImageList_AddIcon($hIL, DllStructGetData($stIcon, 1))
	DestroyIcon(DllStructGetData($stIcon, 1))
	Local $stBIL = DllStructCreate("dword;int[4];uint")
	DllStructSetData($stBIL, 1, $hIL)
	DllStructSetData($stBIL, 2, 1, 1)
	DllStructSetData($stBIL, 2, 1, 2)
	DllStructSetData($stBIL, 2, 1, 3)
	DllStructSetData($stBIL, 2, 1, 4)
	DllStructSetData($stBIL, 3, $nAlign)
	GUICtrlSendMsg($nID, $BCM_SETIMAGELIST, 0, DllStructGetPtr($stBIL))
EndFunc   ;==>Button_AddIcon

Func ExtractIconEx($sIconFile, $nIconID, $ptrIconLarge, $ptrIconSmall, $nIcons)
	Local $nCount = DllCall('shell32.dll', 'int', 'ExtractIconEx', _
			'str', $sIconFile, _
			'int', $nIconID, _
			'ptr', $ptrIconLarge, _
			'ptr', $ptrIconSmall, _
			'int', $nIcons)
	Return $nCount[0]
EndFunc   ;==>ExtractIconEx


Func ImageList_Create($nImageWidth, $nImageHeight, $nFlags, $nInitial, $nGrow)
	$hImageList = DllCall('comctl32.dll', 'hwnd', 'ImageList_Create', 'int', $nImageWidth, 'int', $nImageHeight, 'int', $nFlags, 'int', $nInitial, 'int', $nGrow)
	Return $hImageList[0]
EndFunc   ;==>ImageList_Create

Func ImageList_AddIcon($hIml, $hIcon)
	$nIndex = DllCall('comctl32.dll', 'int', 'ImageList_AddIcon', 'hwnd', $hIml, 'hwnd', $hIcon)
	Return $nIndex[0]
EndFunc   ;==>ImageList_AddIcon

Func ImageList_Destroy($hIml)
	$bResult = DllCall('comctl32.dll', 'int', 'ImageList_Destroy', 'hwnd', $hIml)
	Return $bResult[0]
EndFunc   ;==>ImageList_Destroy

Func DestroyIcon($hIcon)
	$bResult = DllCall('user32.dll', 'int', 'DestroyIcon', 'hwnd', $hIcon)
	Return $bResult[0]
EndFunc   ;==>DestroyIcon

Func _log($String = "")
	_GUICtrlEdit_AppendText($LogEdit, $String)
EndFunc   ;==>_log


Func _PluginSaveSettings()
	IniWrite($PluginSettings, "settings", "InputFile", GUICtrlRead($InputFile_Input))
	IniWrite($PluginSettings, "settings", "OutputFile", GUICtrlRead($OutputFile_Input))
	IniWrite($PluginSettings, "settings", "TabXOffset", GUICtrlRead($TabcontrolsXOffset_input))
	IniWrite($PluginSettings, "settings", "TabYOffset", GUICtrlRead($TabcontrolsYOffset_input))
	
	If GUICtrlRead($ignoreExstyle_checkbox) = $GUI_CHECKED Then
		IniWrite($PluginSettings, "settings", "IgnoreExStyle", "1")
	Else
		IniWrite($PluginSettings, "settings", "IgnoreExStyle", "0")
	EndIf

	If GUICtrlRead($ignoreStyle_checkbox) = $GUI_CHECKED Then
		IniWrite($PluginSettings, "settings", "IgnoreStyle", "1")
	Else
		IniWrite($PluginSettings, "settings", "IgnoreStyle", "0")
	EndIf

EndFunc   ;==>_PluginSaveSettings

Func _PluginLoadSettings()
	GUICtrlSetData($InputFile_Input, IniRead($PluginSettings, "settings", "InputFile", ""))
	GUICtrlSetData($OutputFile_Input, IniRead($PluginSettings, "settings", "OutputFile", ""))
	GUICtrlSetData($TabcontrolsXOffset_input, IniRead($PluginSettings, "settings", "TabXOffset", "5"))
	GUICtrlSetData($TabcontrolsYOffset_input, IniRead($PluginSettings, "settings", "TabYOffset", "26"))
	
	If IniRead($PluginSettings, "settings", "IgnoreStyle", "0") = "1" Then
		GUICtrlSetState($ignoreStyle_checkbox, $GUI_CHECKED)
	Else
		GUICtrlSetState($ignoreStyle_checkbox, $GUI_UNCHECKED)
	EndIf
	
	If IniRead($PluginSettings, "settings", "IgnoreExStyle", "0") = "1" Then
		GUICtrlSetState($ignoreExstyle_checkbox, $GUI_CHECKED)
	Else
		GUICtrlSetState($ignoreExstyle_checkbox, $GUI_UNCHECKED)
	EndIf
EndFunc   ;==>_PluginLoadSettings

Func _ShowOffsetHelp()
	GUISetState(@SW_SHOW, $OffsetHelp)
	GUISetState(@SW_DISABLE, $GUI)
EndFunc   ;==>_ShowOffsetHelp

Func _HideOffsetHelp()
	GUISetState(@SW_ENABLE, $GUI)
	GUISetState(@SW_HIDE, $OffsetHelp)
EndFunc   ;==>_HideOffsetHelp

Func _SelectISFPath()
	$StartDir = _ISNPlugin_Resolve_ISN_AutoIt_Studio_Variable("%projectdir%")
	$Path = FileSaveDialog(_ISNPlugin_Get_langstring(3), $StartDir, "ISN Form Studio 2 GUI (*.isf)", 18, "", $GUI)
	FileChangeDir(@ScriptDir)
	If $Path = "" Or @error Then Return
	$Path = _ISNPlugin_Execute_in_ISN_AutoIt_Studio('_ISN_Pfad_durch_Variablen_ersetzen("' & $Path & '")')
	GUICtrlSetData($OutputFile_Input, $Path)
EndFunc   ;==>_SelectISFPath

Func _SelectkxfPath()
	$Path = FileOpenDialog(_ISNPlugin_Get_langstring(3), "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}", "KODA GUI (*.kxf)", 3, "", $GUI)
	FileChangeDir(@ScriptDir)
	If $Path = "" Or @error Then Return
	$Path = _ISNPlugin_Execute_in_ISN_AutoIt_Studio('_ISN_Pfad_durch_Variablen_ersetzen("' & $Path & '")')
	GUICtrlSetData($InputFile_Input, $Path)
EndFunc   ;==>_SelectkxfPath
